stages:
  - validate
  - plan
  - apply
  - destroy

default:
  image:
    name: hashicorp/terraform:latest
    entrypoint:
      - /usr/bin/env
      - "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin"

  before_script:
    - git fetch origin --prune --unshallow
    - LAST_COMMIT=$(git rev-parse HEAD^1)
    - CHANGED_FILES=$(git diff --name-only $LAST_COMMIT $CI_COMMIT_SHA | grep "Terraform")
    - FOLDER_PATH=$(dirname "$CHANGED_FILES" | head -n 1)
    - VAR_FILE=$(find "$FOLDER_PATH" -type f -name '*.tfvars' -print -quit)
    - cd $FOLDER_PATH
    - terraform init
  # cache:
  #   key: terraform
  #   paths:
  #     - .terraform

terraform_validate:
  stage: validate
  script:
    - terraform validate
  rules:
    - if: '$CI_COMMIT_MESSAGE !~ /\[destroy\]/'
      when: always
      changes: 
      - "Terraform/**/*.tfvars"

terraform_plan:
  stage: plan
  script:
    - terraform plan -var-file=$CI_PROJECT_DIR/$VAR_FILE
  rules:
    - if: '$CI_COMMIT_MESSAGE !~ /\[destroy\]/'
      when: always
      changes: 
      - "Terraform/**/*.tfvars"
  needs:
    - terraform_validate

terraform_apply:
  stage: apply
  script:
    - terraform apply --auto-approve -var-file=$CI_PROJECT_DIR/$VAR_FILE
  rules:
    - if: '$CI_COMMIT_MESSAGE !~ /\[destroy\]/'
      when: always
      changes: 
      - "Terraform/**/*.tfvars"
  needs:
    - terraform_plan

terraform_destroy:
  stage: destroy
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /\[destroy\]/'
      when: on_success
    - when: never
  script:
  - terraform destroy --auto-approve -var-file=$CI_PROJECT_DIR/$VAR_FILE